import { Parameter } from './metadataGenerator';
import * as ts from 'typescript';
import { DecoratorsSchema } from './acceptedDecoratorsSchema';
export declare class ParameterGenerator {
    private readonly parameter;
    private readonly method;
    private readonly path;
    private readonly decoratorsSchema;
    name: string;
    tsoaDecorator: string;
    constructor(parameter: ts.ParameterDeclaration, method: string, path: string, decoratorsSchema: DecoratorsSchema);
    Generate(): Parameter;
    private getCurrentLocation();
    private getRequestParameter(parameter);
    private getBodyPropParameter(parameter);
    private getBodyParameter(parameter);
    private getHeaderParameter(parameter);
    private getQueryParameter(parameter);
    private getPathParameter(parameter);
    private getParameterDescription(node);
    private supportsBodyParameters(method);
    private supportParameterDecorator(decoratorName);
    private supportPathDataType(parameterType);
    private getValidatedType(parameter);
}
